package  {
	import flash.geom.Vector3D;
	
	/**
	 * ...
	 * @author Volgogradetzzz
	 */
	public class FloatColorConverter {
		
		public static function unitFloatToColor24(depth:Number):uint {
			var max24int:Number = 256 * 256 * 256 - 1;
			var v:Vector3D = new Vector3D(max24int / (256 * 256), max24int / 256, max24int);
			v.x *= depth;
			v.y *= depth;
			v.z *= depth;
			
			v.x = Math.floor(v.x) / 255;
			v.y = Math.floor(v.y) / 255;
			v.z = Math.floor(v.z) / 255;
			
			v.z -= v.y * 256.0;
			v.y -= v.x * 256.0;
			
			var r:uint = v.x * 255;
			var g:uint = v.y * 255;
			var b:uint = v.z * 255;
			
			return ((r << 16) | (g << 8) | (b));
		}
		
		public static function color24ToUnitFloat(color:uint):Number {
			var r:uint = (color >> 16) & 0xFF;
			var g:uint = (color >> 8) & 0xFF;
			var b:uint = color & 0xFF;
			
			var decomp:Vector3D = new Vector3D(r / 255, g / 255, b / 255);
			var scale:Vector3D = new Vector3D(255.0 / 256, 255.0 / (256 * 256), 255.0 / (256 * 256 * 256));
			
			return decomp.x * scale.x + decomp.y * scale.y + decomp.z * scale.z;
		}
	}

}