package  {
	import flash.display.Bitmap;
	import flash.geom.Rectangle;
	
	/**
	 * ...
	 * @author Volgogradetzzz
	 */
	public class IsoObject {
		
		public var diffuse:Bitmap;
		public var depth:Bitmap;
		public var shadow:Bitmap;
		
		public var boundingBox:BoundingBox = new BoundingBox();
		public var boundingRect:Rectangle = new Rectangle();
		
		private var _x:Number = 0;
		private var _y:Number = 0;
		private var _z:Number = 0;
		
		private var _cameraAng:Number = 0;
		private var _offsetY:Number = 0;
		private var _shadowOffsetX:Number = 0;
		private var _shadowOffsetY:Number = 0;
		
		function IsoObject(cameraAng:Number, offsetY:Number, shadowOffsetX:Number = 0, shadowOffsetY:Number = 0) {
			_cameraAng = cameraAng;
			_offsetY = offsetY;
			_shadowOffsetX = shadowOffsetX;
			_shadowOffsetY = shadowOffsetY;
		}
		
		public function get x():Number {
			return _x;
		}
		
		public function set x(value:Number):void {
			_x = value;
			
			diffuse.x = _x;
			depth.x = _x;
			shadow.x = _x + _shadowOffsetX;
			
			boundingBox.x = _x;
			boundingRect.x = _x;
		}
		
		public function get y():Number {
			return _y;
		}
		
		public function set y(value:Number):void {
			_y = value;
			
			updateY();
			
			boundingBox.y = _y;
		}
		
		public function get z():Number {
			return _z;
		}
		
		public function set z(value:Number):void {
			_z = value;
			
			updateY();
			
			boundingBox.z = _z;
		}
		
		private function updateY():void {
			var trueY:Number = _y * Math.sin(_cameraAng) - _z;
			
			diffuse.y = trueY + _offsetY;
			depth.y = trueY + _offsetY;
			shadow.y = _y * Math.sin(_cameraAng) + _shadowOffsetY;
			
			boundingRect.y = trueY + _offsetY;
		}
	}
}